"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var moment_1 = __importDefault(require("moment"));
var utils_1 = require("../../utils");
var styles_1 = __importDefault(require("./styles"));
var defaultModalTimeDuration;
var modalEndtime = 0;
var functionDebounceTime = react_native_1.Platform.OS === 'ios' ? 400 : 0;
var ModalBody = /** @class */ (function (_super) {
    __extends(ModalBody, _super);
    function ModalBody() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            countdown: moment_1.default.duration(_this.props.modalTime, 'minutes'),
        };
        _this.handleAppStateChangeForCountdown = function (nextAppState) {
            if (nextAppState === 'active') {
                _this.startCountdown();
            }
        };
        _this.initializeSessionCountdown = function (duration) {
            return duration >= 0
                ? moment_1.default.duration(duration, 'milliseconds')
                : defaultModalTimeDuration;
        };
        _this.startCountdown = function () {
            var duration = modalEndtime - utils_1.getCurrentTimeStamp();
            if (duration > 0) {
                _this.setState({ countdown: _this.initializeSessionCountdown(duration) }, function () { return utils_1.startSessionTimer(_this.handleCountDown, 1000); });
            }
            else {
                _this.handleSessionTimeout(false);
            }
        };
        _this.handleCountDown = function () {
            return _this.setState(function (_a) {
                var countdown = _a.countdown;
                return ({ countdown: countdown.subtract(1, 's') });
            }, function () {
                if (_this.state.countdown.asMilliseconds() <= 0) {
                    _this.handleSessionTimeout(false);
                }
            });
        };
        _this.handleSessionTimeout = function (isStillAuthed, manualPress) {
            _this.resetCountdown();
            _this.props.hideModal();
            utils_1.stopSessionTimer(isStillAuthed);
            if (_this.props.onTimerEnd && !isStillAuthed && !manualPress) {
                setTimeout(_this.props.onTimerEnd, functionDebounceTime);
            }
        };
        _this.handleYesBtnPress = function () {
            var onPress = _this.props.confirmButtonConfigs.onPress;
            _this.handleSessionTimeout(true, true);
            if (onPress) {
                setTimeout(onPress, functionDebounceTime);
            }
        };
        _this.handleNoBtnPress = function () {
            var onPress = _this.props.cancelButtonConfigs.onPress;
            _this.handleSessionTimeout(false, true);
            if (onPress) {
                setTimeout(onPress, functionDebounceTime);
            }
        };
        _this.resetCountdown = function () {
            return _this.setState({
                countdown: _this.initializeSessionCountdown(-1),
            });
        };
        return _this;
    }
    ModalBody.prototype.componentDidMount = function () {
        var modalConfigs = this.props.modalConfigs;
        react_native_1.AppState.addEventListener('change', this.handleAppStateChangeForCountdown);
        defaultModalTimeDuration = moment_1.default.duration(this.props.modalTime, 'minutes');
        modalEndtime =
            defaultModalTimeDuration.asMilliseconds() + utils_1.getBackgroundTimerEndTime();
        if (modalConfigs && react_native_1.Platform.OS === 'ios') {
            // Functions are called 10ms after the modal is hidden
            functionDebounceTime =
                Math.max(modalConfigs.animationInTiming || 300, modalConfigs.animationOutTiming || 300, modalConfigs.backdropTransitionInTiming || 300, modalConfigs.backdropTransitionOutTiming || 300) + 100;
        }
        this.startCountdown();
    };
    ModalBody.prototype.componentWillUnmount = function () {
        react_native_1.AppState.removeEventListener('change', this.handleAppStateChangeForCountdown);
    };
    ModalBody.prototype.render = function () {
        var countdown = this.state.countdown;
        var _a = this.props, containerStyle = _a.containerStyle, title = _a.title, titleStyle = _a.titleStyle, subtitle = _a.subtitle, subtitleStyle = _a.subtitleStyle, countdownTextStyle = _a.countdownTextStyle, buttonsContainerStyle = _a.buttonsContainerStyle, cancelButtonConfigs = _a.cancelButtonConfigs, confirmButtonConfigs = _a.confirmButtonConfigs;
        return (react_1.default.createElement(react_native_1.View, { style: [styles_1.default.modalContainer, containerStyle] },
            react_1.default.createElement(react_native_1.View, { style: styles_1.default.textContainer },
                react_1.default.createElement(react_native_1.Text, { style: [styles_1.default.title, titleStyle], accessible: true }, title),
                react_1.default.createElement(react_native_1.Text, { style: [styles_1.default.countdown, countdownTextStyle], accessible: true }, utils_1.formatCountdown(countdown)),
                react_1.default.createElement(react_native_1.Text, { style: [styles_1.default.subtitle, subtitleStyle], accessible: true }, subtitle)),
            react_1.default.createElement(react_native_1.View, { style: [styles_1.default.btnRow, buttonsContainerStyle] },
                react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: this.handleNoBtnPress, style: [styles_1.default.modalBtn, cancelButtonConfigs.buttonStyle] },
                    react_1.default.createElement(react_native_1.View, { style: cancelButtonConfigs.buttonViewStyle },
                        react_1.default.createElement(react_native_1.Text, { style: [styles_1.default.modalBtnText, cancelButtonConfigs.textStyle] }, cancelButtonConfigs.text))),
                react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: this.handleYesBtnPress, style: [styles_1.default.modalBtn, confirmButtonConfigs.buttonStyle] },
                    react_1.default.createElement(react_native_1.View, { style: confirmButtonConfigs.buttonViewStyle },
                        react_1.default.createElement(react_native_1.Text, { style: [styles_1.default.modalBtnText, confirmButtonConfigs.textStyle] }, confirmButtonConfigs.text))))));
    };
    return ModalBody;
}(react_1.Component));
exports.default = ModalBody;
