"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_modal_1 = __importDefault(require("react-native-modal"));
var ModalBody_1 = __importDefault(require("../ModalBody"));
var utils_1 = require("../../utils");
var types_1 = require("./types");
var styles_1 = __importDefault(require("./styles"));
var SessionTimerModal = /** @class */ (function (_super) {
    __extends(SessionTimerModal, _super);
    function SessionTimerModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isShowModal: false,
        };
        _this.hideModal = function () { return _this.setState({ isShowModal: false }); };
        _this.toggleSessionTimerModal = function () {
            return _this.setState(function (_a) {
                var isShowModal = _a.isShowModal;
                return ({ isShowModal: !isShowModal });
            });
        };
        return _this;
    }
    SessionTimerModal.prototype.componentDidMount = function () {
        utils_1.init(__assign({}, this.props, { defaultCallback: this.toggleSessionTimerModal, hideModal: this.hideModal }));
        react_native_1.AppState.addEventListener('change', utils_1.handleAppStateChangeForBackgroundTimer);
    };
    SessionTimerModal.prototype.componentWillUnmount = function () {
        react_native_1.AppState.removeEventListener('change', utils_1.handleAppStateChangeForBackgroundTimer);
    };
    SessionTimerModal.prototype.render = function () {
        var isShowModal = this.state.isShowModal;
        var _a = this.props, children = _a.children, modalConfigs = _a.modalConfigs;
        return (react_1.default.createElement(react_native_1.View, { style: styles_1.default.container, pointerEvents: "box-none" },
            children,
            react_1.default.createElement(react_native_modal_1.default, __assign({ useNativeDriver: true, hideModalContentWhileAnimating: true }, modalConfigs, { isVisible: isShowModal }),
                react_1.default.createElement(ModalBody_1.default, __assign({}, this.props, { hideModal: this.hideModal })))));
    };
    SessionTimerModal.defaultProps = types_1.defaultProps;
    return SessionTimerModal;
}(react_1.Component));
exports.default = SessionTimerModal;
